
_App_Init:

;electronique_metronome_004_16f628.mpas,62 :: 		begin
;electronique_metronome_004_16f628.mpas,63 :: 		CMCON := 7;
	MOVLW      7
	MOVWF      CMCON+0
;electronique_metronome_004_16f628.mpas,64 :: 		OPTION_REG.NOT_RBPU := 0;  // enable pullup
	BCF        OPTION_REG+0, 7
;electronique_metronome_004_16f628.mpas,65 :: 		TRISA := $00;              // porta as input, but RA4 as output
	CLRF       TRISA+0
;electronique_metronome_004_16f628.mpas,66 :: 		TRISB := %11100000;        // port B as outputs
	MOVLW      224
	MOVWF      TRISB+0
;electronique_metronome_004_16f628.mpas,67 :: 		PORTA := 0;
	CLRF       PORTA+0
;electronique_metronome_004_16f628.mpas,68 :: 		PORTB := 0;
	CLRF       PORTB+0
;electronique_metronome_004_16f628.mpas,69 :: 		INTCON.RBIE := 1;
	BSF        INTCON+0, 3
;electronique_metronome_004_16f628.mpas,70 :: 		INTCON.GIE := 1;
	BSF        INTCON+0, 7
;electronique_metronome_004_16f628.mpas,71 :: 		Sound_Init(PORTB, 4);
	MOVLW      PORTB+0
	MOVWF      FARG_Sound_Init_snd_port+0
	MOVLW      4
	MOVWF      FARG_Sound_Init_snd_pin+0
	CALL       _Sound_Init+0
;electronique_metronome_004_16f628.mpas,74 :: 		iRythmIndex := 4;
	MOVLW      4
	MOVWF      _iRythmIndex+0
;electronique_metronome_004_16f628.mpas,75 :: 		iLedIndex := 0;
	CLRF       _iLedIndex+0
;electronique_metronome_004_16f628.mpas,76 :: 		end;
	RETURN
; end of _App_Init

_RythmSignChange:

;electronique_metronome_004_16f628.mpas,79 :: 		begin
;electronique_metronome_004_16f628.mpas,89 :: 		iRythmIndex := iRythmSign;
	MOVF       _iRythmSign+0, 0
	MOVWF      _iRythmIndex+0
;electronique_metronome_004_16f628.mpas,90 :: 		iLedIndex := 0;
	CLRF       _iLedIndex+0
;electronique_metronome_004_16f628.mpas,91 :: 		bCountUp := true;
	MOVLW      255
	MOVWF      _bCountUp+0
;electronique_metronome_004_16f628.mpas,92 :: 		end;
	RETURN
; end of _RythmSignChange

_Prefs_Load:

;electronique_metronome_004_16f628.mpas,97 :: 		begin
;electronique_metronome_004_16f628.mpas,99 :: 		iTmp := EEProm_Read(cAddrDelaySpeed);
	MOVLW      1
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Prefs_Load_iTmp+0
;electronique_metronome_004_16f628.mpas,100 :: 		if iTmp < cDelaySpeedMax then
	MOVLW      255
	SUBWF      R0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Prefs_Load4
;electronique_metronome_004_16f628.mpas,101 :: 		iDelaySpeed := iTmp
	MOVF       Prefs_Load_iTmp+0, 0
	MOVWF      _iDelaySpeed+0
	GOTO       L__Prefs_Load5
;electronique_metronome_004_16f628.mpas,102 :: 		else
L__Prefs_Load4:
;electronique_metronome_004_16f628.mpas,104 :: 		iDelaySpeed := 80;
	MOVLW      80
	MOVWF      _iDelaySpeed+0
;electronique_metronome_004_16f628.mpas,105 :: 		EEProm_Write(cAddrDelaySpeed, iDelaySpeed);
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVLW      80
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_metronome_004_16f628.mpas,106 :: 		end;
L__Prefs_Load5:
;electronique_metronome_004_16f628.mpas,108 :: 		iTmp := EEProm_Read(cAddrRythmSign);
	MOVLW      2
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Prefs_Load_iTmp+0
;electronique_metronome_004_16f628.mpas,109 :: 		if iTmp <= cRythmSignMax then
	MOVF       R0+0, 0
	SUBLW      6
	BTFSS      STATUS+0, 0
	GOTO       L__Prefs_Load7
;electronique_metronome_004_16f628.mpas,110 :: 		iRythmSign := iTmp
	MOVF       Prefs_Load_iTmp+0, 0
	MOVWF      _iRythmSign+0
	GOTO       L__Prefs_Load8
;electronique_metronome_004_16f628.mpas,111 :: 		else
L__Prefs_Load7:
;electronique_metronome_004_16f628.mpas,113 :: 		iRythmSign := 4;
	MOVLW      4
	MOVWF      _iRythmSign+0
;electronique_metronome_004_16f628.mpas,114 :: 		EEProm_Write(cAddrRythmSign, iRythmSign);
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	MOVLW      4
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_metronome_004_16f628.mpas,115 :: 		end;
L__Prefs_Load8:
;electronique_metronome_004_16f628.mpas,116 :: 		RythmSignChange;
	CALL       _RythmSignChange+0
;electronique_metronome_004_16f628.mpas,117 :: 		end;
	RETURN
; end of _Prefs_Load

_Prefs_Save:

;electronique_metronome_004_16f628.mpas,120 :: 		begin
;electronique_metronome_004_16f628.mpas,122 :: 		EEProm_Write(cAddrDelaySpeed, iDelaySpeed);
	MOVLW      1
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _iDelaySpeed+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_metronome_004_16f628.mpas,124 :: 		EEProm_Write(cAddrRythmSign, iRythmSign);
	MOVLW      2
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       _iRythmSign+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_metronome_004_16f628.mpas,125 :: 		end;
	RETURN
; end of _Prefs_Save

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_metronome_004_16f628.mpas,128 :: 		begin
;electronique_metronome_004_16f628.mpas,129 :: 		if INTCON.RBIF then
	BTFSS      INTCON+0, 0
	GOTO       L__Interrupt12
;electronique_metronome_004_16f628.mpas,131 :: 		if In_SpeedDown = 0 then
	BTFSC      RB5_bit+0, 5
	GOTO       L__Interrupt15
;electronique_metronome_004_16f628.mpas,133 :: 		if iDelaySpeed < cDelaySpeedMax then
	MOVLW      255
	SUBWF      _iDelaySpeed+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt18
;electronique_metronome_004_16f628.mpas,134 :: 		iDelaySpeed := iDelaySpeed + 1;
	INCF       _iDelaySpeed+0, 1
L__Interrupt18:
;electronique_metronome_004_16f628.mpas,135 :: 		Out_Led_SpeedMin := (iDelaySpeed = cDelaySpeedMin);
	MOVF       _iDelaySpeed+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__Interrupt65
	BCF        RA6_bit+0, 6
	GOTO       L__Interrupt66
L__Interrupt65:
	BSF        RA6_bit+0, 6
L__Interrupt66:
;electronique_metronome_004_16f628.mpas,136 :: 		Out_Led_SpeedMax := (iDelaySpeed = cDelaySpeedMax);
	MOVF       _iDelaySpeed+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__Interrupt67
	BCF        RA7_bit+0, 7
	GOTO       L__Interrupt68
L__Interrupt67:
	BSF        RA7_bit+0, 7
L__Interrupt68:
;electronique_metronome_004_16f628.mpas,137 :: 		end;
L__Interrupt15:
;electronique_metronome_004_16f628.mpas,138 :: 		if In_SpeedUp = 0 then
	BTFSC      RB6_bit+0, 6
	GOTO       L__Interrupt21
;electronique_metronome_004_16f628.mpas,140 :: 		if iDelaySpeed > cDelaySpeedMin then
	MOVF       _iDelaySpeed+0, 0
	SUBLW      1
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt24
;electronique_metronome_004_16f628.mpas,141 :: 		iDelaySpeed := iDelaySpeed - 1;
	DECF       _iDelaySpeed+0, 1
L__Interrupt24:
;electronique_metronome_004_16f628.mpas,142 :: 		Out_Led_SpeedMin := (iDelaySpeed = cDelaySpeedMin);
	MOVF       _iDelaySpeed+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__Interrupt69
	BCF        RA6_bit+0, 6
	GOTO       L__Interrupt70
L__Interrupt69:
	BSF        RA6_bit+0, 6
L__Interrupt70:
;electronique_metronome_004_16f628.mpas,143 :: 		Out_Led_SpeedMax := (iDelaySpeed = cDelaySpeedMax);
	MOVF       _iDelaySpeed+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__Interrupt71
	BCF        RA7_bit+0, 7
	GOTO       L__Interrupt72
L__Interrupt71:
	BSF        RA7_bit+0, 7
L__Interrupt72:
;electronique_metronome_004_16f628.mpas,144 :: 		end;
L__Interrupt21:
;electronique_metronome_004_16f628.mpas,145 :: 		if In_RythmSign = 0 then
	BTFSC      RB7_bit+0, 7
	GOTO       L__Interrupt27
;electronique_metronome_004_16f628.mpas,147 :: 		if iRythmSign < cRythmSignMax then
	MOVLW      6
	SUBWF      _iRythmSign+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt30
;electronique_metronome_004_16f628.mpas,148 :: 		iRythmSign := iRythmSign + 1
	INCF       _iRythmSign+0, 1
	GOTO       L__Interrupt31
;electronique_metronome_004_16f628.mpas,149 :: 		else
L__Interrupt30:
;electronique_metronome_004_16f628.mpas,150 :: 		iRythmSign := cRythmSignMin;
	MOVLW      1
	MOVWF      _iRythmSign+0
L__Interrupt31:
;electronique_metronome_004_16f628.mpas,151 :: 		RythmSignChange;
	CALL       _RythmSignChange+0
;electronique_metronome_004_16f628.mpas,152 :: 		end;
L__Interrupt27:
;electronique_metronome_004_16f628.mpas,153 :: 		bModified := true;
	MOVLW      255
	MOVWF      _bModified+0
;electronique_metronome_004_16f628.mpas,154 :: 		INTCON.RBIF := 0;
	BCF        INTCON+0, 0
;electronique_metronome_004_16f628.mpas,155 :: 		end;
L__Interrupt12:
;electronique_metronome_004_16f628.mpas,156 :: 		end;
L__Interrupt64:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_DoBip:

;electronique_metronome_004_16f628.mpas,159 :: 		begin
;electronique_metronome_004_16f628.mpas,160 :: 		iRythmIndex := iRythmIndex + 1;
	INCF       _iRythmIndex+0, 1
;electronique_metronome_004_16f628.mpas,161 :: 		if iRythmIndex > iRythmSign then
	MOVF       _iRythmIndex+0, 0
	SUBWF      _iRythmSign+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__DoBip34
;electronique_metronome_004_16f628.mpas,163 :: 		Sound_Play(500, cDelayBip);
	MOVLW      244
	MOVWF      FARG_Sound_Play_freq_in_hz+0
	MOVLW      1
	MOVWF      FARG_Sound_Play_freq_in_hz+1
	MOVLW      25
	MOVWF      FARG_Sound_Play_duration_ms+0
	CLRF       FARG_Sound_Play_duration_ms+1
	CALL       _Sound_Play+0
;electronique_metronome_004_16f628.mpas,164 :: 		iRythmIndex := 1;
	MOVLW      1
	MOVWF      _iRythmIndex+0
;electronique_metronome_004_16f628.mpas,165 :: 		end
	GOTO       L__DoBip35
;electronique_metronome_004_16f628.mpas,166 :: 		else
L__DoBip34:
;electronique_metronome_004_16f628.mpas,168 :: 		Sound_Play(250, cDelayBip);
	MOVLW      250
	MOVWF      FARG_Sound_Play_freq_in_hz+0
	CLRF       FARG_Sound_Play_freq_in_hz+1
	MOVLW      25
	MOVWF      FARG_Sound_Play_duration_ms+0
	CLRF       FARG_Sound_Play_duration_ms+1
	CALL       _Sound_Play+0
;electronique_metronome_004_16f628.mpas,169 :: 		end;
L__DoBip35:
;electronique_metronome_004_16f628.mpas,170 :: 		end;
	RETURN
; end of _DoBip

_DisplayRefresh:

;electronique_metronome_004_16f628.mpas,173 :: 		begin
;electronique_metronome_004_16f628.mpas,174 :: 		if bCountUp then
	MOVF       _bCountUp+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__DisplayRefresh38
;electronique_metronome_004_16f628.mpas,176 :: 		if iLedIndex < 7 then
	MOVLW      7
	SUBWF      _iLedIndex+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__DisplayRefresh41
;electronique_metronome_004_16f628.mpas,177 :: 		iLedIndex := iLedIndex + 1;
	INCF       _iLedIndex+0, 1
L__DisplayRefresh41:
;electronique_metronome_004_16f628.mpas,178 :: 		if iLedIndex = 7 then
	MOVF       _iLedIndex+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__DisplayRefresh44
;electronique_metronome_004_16f628.mpas,179 :: 		bCountUp := false;
	CLRF       _bCountUp+0
L__DisplayRefresh44:
;electronique_metronome_004_16f628.mpas,180 :: 		end
	GOTO       L__DisplayRefresh39
;electronique_metronome_004_16f628.mpas,181 :: 		else
L__DisplayRefresh38:
;electronique_metronome_004_16f628.mpas,183 :: 		if iLedIndex > 0 then
	MOVF       _iLedIndex+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__DisplayRefresh47
;electronique_metronome_004_16f628.mpas,184 :: 		iLedIndex := iLedIndex - 1;
	DECF       _iLedIndex+0, 1
L__DisplayRefresh47:
;electronique_metronome_004_16f628.mpas,185 :: 		if iLedIndex = 0 then
	MOVF       _iLedIndex+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__DisplayRefresh50
;electronique_metronome_004_16f628.mpas,186 :: 		bCountUp := true;
	MOVLW      255
	MOVWF      _bCountUp+0
L__DisplayRefresh50:
;electronique_metronome_004_16f628.mpas,187 :: 		end;
L__DisplayRefresh39:
;electronique_metronome_004_16f628.mpas,188 :: 		Out_Led_1 := (iLedIndex = 0);
	MOVF       _iLedIndex+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh73
	BCF        RA0_bit+0, 0
	GOTO       L__DisplayRefresh74
L__DisplayRefresh73:
	BSF        RA0_bit+0, 0
L__DisplayRefresh74:
;electronique_metronome_004_16f628.mpas,189 :: 		Out_Led_2 := (iLedIndex = 1);
	MOVF       _iLedIndex+0, 0
	XORLW      1
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh75
	BCF        RA1_bit+0, 1
	GOTO       L__DisplayRefresh76
L__DisplayRefresh75:
	BSF        RA1_bit+0, 1
L__DisplayRefresh76:
;electronique_metronome_004_16f628.mpas,190 :: 		Out_Led_3 := (iLedIndex = 2);
	MOVF       _iLedIndex+0, 0
	XORLW      2
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh77
	BCF        RA2_bit+0, 2
	GOTO       L__DisplayRefresh78
L__DisplayRefresh77:
	BSF        RA2_bit+0, 2
L__DisplayRefresh78:
;electronique_metronome_004_16f628.mpas,191 :: 		Out_Led_4 := (iLedIndex = 3);
	MOVF       _iLedIndex+0, 0
	XORLW      3
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh79
	BCF        RA3_bit+0, 3
	GOTO       L__DisplayRefresh80
L__DisplayRefresh79:
	BSF        RA3_bit+0, 3
L__DisplayRefresh80:
;electronique_metronome_004_16f628.mpas,192 :: 		Out_Led_5 := (iLedIndex = 4);
	MOVF       _iLedIndex+0, 0
	XORLW      4
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh81
	BCF        RB0_bit+0, 0
	GOTO       L__DisplayRefresh82
L__DisplayRefresh81:
	BSF        RB0_bit+0, 0
L__DisplayRefresh82:
;electronique_metronome_004_16f628.mpas,193 :: 		Out_Led_6 := (iLedIndex = 5);
	MOVF       _iLedIndex+0, 0
	XORLW      5
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh83
	BCF        RB1_bit+0, 1
	GOTO       L__DisplayRefresh84
L__DisplayRefresh83:
	BSF        RB1_bit+0, 1
L__DisplayRefresh84:
;electronique_metronome_004_16f628.mpas,194 :: 		Out_Led_7 := (iLedIndex = 6);
	MOVF       _iLedIndex+0, 0
	XORLW      6
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh85
	BCF        RB2_bit+0, 2
	GOTO       L__DisplayRefresh86
L__DisplayRefresh85:
	BSF        RB2_bit+0, 2
L__DisplayRefresh86:
;electronique_metronome_004_16f628.mpas,195 :: 		Out_Led_8 := (iLedIndex = 7);
	MOVF       _iLedIndex+0, 0
	XORLW      7
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__DisplayRefresh87
	BCF        RB3_bit+0, 3
	GOTO       L__DisplayRefresh88
L__DisplayRefresh87:
	BSF        RB3_bit+0, 3
L__DisplayRefresh88:
;electronique_metronome_004_16f628.mpas,196 :: 		end;
	RETURN
; end of _DisplayRefresh

_main:

;electronique_metronome_004_16f628.mpas,199 :: 		begin
;electronique_metronome_004_16f628.mpas,200 :: 		App_Init;
	CALL       _App_Init+0
;electronique_metronome_004_16f628.mpas,201 :: 		Prefs_Load;
	CALL       _Prefs_Load+0
;electronique_metronome_004_16f628.mpas,202 :: 		while true do
L__main54:
;electronique_metronome_004_16f628.mpas,204 :: 		if bModified then
	MOVF       _bModified+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main59
;electronique_metronome_004_16f628.mpas,205 :: 		Prefs_Save;
	CALL       _Prefs_Save+0
L__main59:
;electronique_metronome_004_16f628.mpas,206 :: 		DisplayRefresh;
	CALL       _DisplayRefresh+0
;electronique_metronome_004_16f628.mpas,207 :: 		if (iLedIndex = 0) or (iLedIndex = 7) then
	MOVF       _iLedIndex+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _iLedIndex+0, 0
	XORLW      7
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main62
;electronique_metronome_004_16f628.mpas,208 :: 		DoBip;
	CALL       _DoBip+0
L__main62:
;electronique_metronome_004_16f628.mpas,209 :: 		VDelay_ms(iDelaySpeed);
	MOVF       _iDelaySpeed+0, 0
	MOVWF      FARG_VDelay_ms_Time_ms+0
	CLRF       FARG_VDelay_ms_Time_ms+1
	CALL       _VDelay_ms+0
;electronique_metronome_004_16f628.mpas,210 :: 		end;
	GOTO       L__main54
;electronique_metronome_004_16f628.mpas,211 :: 		end.
	GOTO       $+0
; end of _main
